    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------------
    028     * StandardXYItemLabelGenerator.java
    029     * ---------------------------------
    030     * (C) Copyright 2001-2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: StandardXYItemLabelGenerator.java,v 1.2.2.3 2007/02/02 11:07:00 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 13-Dec-2001 : Version 1 (DG);
    040     * 16-Jan-2002 : Completed Javadocs (DG);
    041     * 02-Apr-2002 : Modified to handle null y-values (DG);
    042     * 09-Apr-2002 : Added formatting objects for the x and y values (DG);
    043     * 30-May-2002 : Added series name to standard tool tip (DG);
    044     * 26-Sep-2002 : Fixed errors reported by Checkstyle (DG);
    045     * 23-Mar-2003 : Implemented Serializable (DG);
    046     * 13-Aug-2003 : Implemented Cloneable (DG);
    047     * 17-Nov-2003 : Implemented PublicCloneable (DG);
    048     * 25-Feb-2004 : Renamed XYToolTipGenerator --> XYItemLabelGenerator and
    049     *               StandardXYToolTipGenerator -->
    050     *               StandardXYItemLabelGenerator (DG);
    051     * 26-Feb-2004 : Modified to use MessageFormat (DG);
    052     * 27-Feb-2004 : Added abstract superclass (DG);
    053     * 11-May-2004 : Split into StandardXYToolTipGenerator and
    054     *               StandardXYLabelGenerator (DG);
    055     * 20-Apr-2005 : Renamed StandardXYLabelGenerator
    056     *               --> StandardXYItemLabelGenerator (DG);
    057     * ------------- JFREECHART 1.0.x ---------------------------------------------
    058     * 25-Jan-2007 : Added new constructor - see bug 1624067 (DG);
    059     *
    060     */
    061
    062    package org.jfree.chart.labels;
    063
    064    import java.io.Serializable;
    065    import java.text.DateFormat;
    066    import java.text.NumberFormat;
    067
    068    import org.jfree.data.xy.XYDataset;
    069    import org.jfree.util.PublicCloneable;
    070
    071    /**
    072     * A standard item label generator for plots that use data from an
    073     * {@link org.jfree.data.xy.XYDataset}.
    074     */
    075    public class StandardXYItemLabelGenerator extends AbstractXYItemLabelGenerator
    076                                              implements XYItemLabelGenerator,
    077                                                         Cloneable,
    078                                                         PublicCloneable,
    079                                                         Serializable {
    080
    081        /** For serialization. */
    082        private static final long serialVersionUID = 7807668053171837925L;
    083
    084        /** The default item label format. */
    085        public static final String DEFAULT_ITEM_LABEL_FORMAT = "{2}";
    086
    087        /**
    088         * Creates an item label generator using default number formatters.
    089         */
    090        public StandardXYItemLabelGenerator() {
    091            this(DEFAULT_ITEM_LABEL_FORMAT, NumberFormat.getNumberInstance(),
    092                    NumberFormat.getNumberInstance());
    093        }
    094
    095
    096        /**
    097         * Creates an item label generator using the specified number formatters.
    098         *
    099         * @param formatString  the item label format string (<code>null</code> not
    100         *                      permitted).
    101         * @param xFormat  the format object for the x values (<code>null</code>
    102         *                 not permitted).
    103         * @param yFormat  the format object for the y values (<code>null</code>
    104         *                 not permitted).
    105         */
    106        public StandardXYItemLabelGenerator(String formatString,
    107                NumberFormat xFormat, NumberFormat yFormat) {
    108
    109            super(formatString, xFormat, yFormat);
    110        }
    111
    112        /**
    113         * Creates an item label generator using the specified formatters.
    114         *
    115         * @param formatString  the item label format string (<code>null</code>
    116         *                      not permitted).
    117         * @param xFormat  the format object for the x values (<code>null</code>
    118         *                 not permitted).
    119         * @param yFormat  the format object for the y values (<code>null</code>
    120         *                 not permitted).
    121         */
    122        public StandardXYItemLabelGenerator(String formatString,
    123                DateFormat xFormat, NumberFormat yFormat) {
    124
    125            super(formatString, xFormat, yFormat);
    126        }
    127
    128        /**
    129         * Creates an item label generator using the specified formatters (a
    130         * number formatter for the x-values and a date formatter for the
    131         * y-values).
    132         *
    133         * @param formatString  the item label format string (<code>null</code>
    134         *                      not permitted).
    135         * @param xFormat  the format object for the x values (<code>null</code>
    136         *                 permitted).
    137         * @param yFormat  the format object for the y values (<code>null</code>
    138         *                 not permitted).
    139         *
    140         * @since 1.0.4
    141         */
    142        public StandardXYItemLabelGenerator(String formatString,
    143                NumberFormat xFormat, DateFormat yFormat) {
    144
    145            super(formatString, xFormat, yFormat);
    146        }
    147
    148        /**
    149         * Creates a label generator using the specified date formatters.
    150         *
    151         * @param formatString  the label format string (<code>null</code> not
    152         *                      permitted).
    153         * @param xFormat  the format object for the x values (<code>null</code>
    154         *                 not permitted).
    155         * @param yFormat  the format object for the y values (<code>null</code>
    156         *                 not permitted).
    157         */
    158        public StandardXYItemLabelGenerator(String formatString,
    159                DateFormat xFormat, DateFormat yFormat) {
    160
    161            super(formatString, xFormat, yFormat);
    162        }
    163
    164        /**
    165         * Generates the item label text for an item in a dataset.
    166         *
    167         * @param dataset  the dataset (<code>null</code> not permitted).
    168         * @param series  the series index (zero-based).
    169         * @param item  the item index (zero-based).
    170         *
    171         * @return The label text (possibly <code>null</code>).
    172         */
    173        public String generateLabel(XYDataset dataset, int series, int item) {
    174            return generateLabelString(dataset, series, item);
    175        }
    176
    177        /**
    178         * Returns an independent copy of the generator.
    179         *
    180         * @return A clone.
    181         *
    182         * @throws CloneNotSupportedException if cloning is not supported.
    183         */
    184        public Object clone() throws CloneNotSupportedException {
    185            return super.clone();
    186        }
    187
    188        /**
    189         * Tests this object for equality with an arbitrary object.
    190         *
    191         * @param obj  the other object (<code>null</code> permitted).
    192         *
    193         * @return A boolean.
    194         */
    195        public boolean equals(Object obj) {
    196            if (obj == this) {
    197                return true;
    198            }
    199            if (!(obj instanceof StandardXYItemLabelGenerator)) {
    200                return false;
    201            }
    202            return super.equals(obj);
    203        }
    204
    205    }